#if !defined(AFX_CAPTURE_H__E5620556_A135_11D1_A1BF_444553540000__INCLUDED_)
#define AFX_CAPTURE_H__E5620556_A135_11D1_A1BF_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Capture.h : header file
//

//Video for Window 
#include<vfw.h>

#ifndef _VFW
#define _VFW
#pragma comment(lib,"vfw32.lib")
#endif

//ý
#include<mmsystem.h>

#ifndef _WINMM
#define _WINMM 

#pragma comment(lib,"winmm.lib")
#endif

/////////////////////////////////////////////////////////////////////////////
// CCapture window

/////////////////////////////////////////////////////////////////////////////
// CCapture
//
// ׽(汾1.0)
//
// ɹ: ò׽,ɲ׽
//
// 汾: 
//
/////////////////////////////////////////////////////////////////////////////

class CCapture : public CWnd
{
// Construction
public:
	CCapture();
	CCapture(CRect rect , HWND hwnd = NULL , CString title = _T("") , int id = 0);
// Attributes
public:

private:	
	int m_nWindowHided;//شڴ
	BOOL m_bOverLay;//ʹøǷʽ
	static CCapture * m_pStaticCap;//ָ̬
//	CFile * m_pfileCapData;
//	CString m_fileCapDataName;
	CString m_strCapTitle;//׽ڱ
	CRect m_CapRect;//׽
	int m_nCapRate;//׽
	
	int m_nDeviceCount;//豸
	CStringArray m_strDeviceVersion;//豸汾Ϣб
	CStringArray m_strDeviceName;//豸Ϣб
	static BOOL m_bDrvUsed;//豸Ƿʹ
	DWORD m_CapWndStyle;//׽ڷ
	int m_nID;//ڱʶ
	HWND m_hwndParent;//ھ
	HWND m_hCapWnd;//׽ھ


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCapture)
	//}}AFX_VIRTUAL

// Implementation
private:
	//Ĭдļص
	static LRESULT CALLBACK CallbackWriteToFile(HWND hWnd,LPVIDEOHDR lpVHdr);
	//Ĭ״̬ص
	static LRESULT CALLBACK CallbackStatus(HWND hWnd, int nID,LPSTR lpStatusText);
	//Ĭϴص
	static LRESULT CALLBACK CallbackError(HWND hWnd, int nErrID,LPSTR lpErrorText);
	//ĬϿƻص
	static LRESULT CALLBACK CallbackControl( HWND hWnd,int nState);
	//Ĭݳص
	static LRESULT CALLBACK CallbackYield( HWND hWnd );

public:	
	//ʼʾЧʹøǣʹԤ
	void InitDisplay();
	//Ƿʹø
	BOOL IsOverlay(){return m_bOverLay;};
	//˳׽
	void Quit();
	//ʼ豸׽
	BOOL Init(int no = 0);
	//õ豸Ϣ
	void GetDeviceInfo();
	////õ豸
	int GetDeviceCount();

	//ôλ
	BOOL SetWindowPos(HWND hWndInsertAfter, int X, int Y, int cx, int cy, UINT uFlags);
	//õ׽ͼС
	CSize GetImageSize();

	//õ豸
	BOOL GetDrvCap(CAPDRIVERCAPS * pCap);
	//õ豸״̬
	BOOL GetCapStatus(CAPSTATUS * pStatus);

	//豸
	BOOL ConnectDriver(int no = 0);
	//Ͽ豸
	BOOL DisconnectDriver();

	//Ԥ
	BOOL OpenPreview();
	//رԤ
	BOOL ClosePreview();

	//򿪸
	BOOL EnableOverlay();
	//رո
	BOOL DisableOverlay();

	//ز׽
	BOOL HideWindow();
	//ʾ׽
	BOOL ShowWindow();

	//ƵԴԻ
	BOOL DlgSetVideoSource();
	//ƵʽԻ
	BOOL DlgSetVideoFormat();
	//ƵѹԻ
	BOOL DlgSetVideoCompression();
	//ƵʾԻ
	BOOL DlgSetVideoDisplay();

	//ò׽
	BOOL SetCapSetup(CAPTUREPARMS * pparm);
	//õ׽
	BOOL GetCapSetup(CAPTUREPARMS * pparm);
	
	//õ׽ʱ
	int GetCapTime();
	//ò׽ʱ
	BOOL SetCapTime(int time);
	//õ׽֡
	int GetCapRate();
	//ò׽֡
	BOOL SetCapRate(int rate);

	//Ƶʽ
	BOOL SetVideoFormat(BITMAPINFO * psVideoFormat);
	BOOL SetVideoFormat(int width,int height,int bitcount = 0,int compress = 0);
	//õƵʽ
	DWORD GetVideoFormat(BITMAPINFO * psVideoFormat);
	//õƵʽߴ
	DWORD GetVideoFormatSize();

	//Ƿ׽Ƶ
	BOOL GetCapAudio();
	//Ƿ׽Ƶ
	BOOL SetCapAudio(BOOL flag);
	//õƵʽС
	DWORD GetAudioFormatSize();
	//õƵʽ
	DWORD GetAudioFormat(WAVEFORMATEX * pwfex);
	//Ƶʽ
	BOOL SetAudioFormat(WAVEFORMATEX * pwfex);

	//Ƿʹݳ
	BOOL GetYield();
	//Ƿʹݳ
	BOOL SetYield(BOOL flag);

	//õ׽ļ
	CString & GetDataFileName();
	//ò׽ļ
	BOOL SetCapFileName(CString aviname);

	//Ԥȷļռ
	BOOL PreFileAlloc(DWORD size);
	//׽ļ
	BOOL CaptureToFile();
	//׽
	BOOL CaptureToData();
	//ֹͣ
	BOOL CaptureStop();
	//׽֡ͼ
	BOOL CaptureFrame(CString strDibName);

	//Ϣ
	BOOL SetInfoChunk(CAPINFOCHUNK * pcic);

	//ݳص
	BOOL SetYieldCallback(LPVOID fpyieldcallback = CallbackYield);
	//ÿƻص
	BOOL SetControlCallback(LPVOID fpcontrolcallback = CallbackControl);
	//Ƶص
	BOOL SetVideoCallback(LPVOID fpvideocallback);
	//״̬ص
	BOOL SetStatusCallback(LPVOID fpstatuscallback = CallbackStatus);
	//Ǵص
	BOOL SetErrorCallback(LPVOID fperrorcallback = CallbackError);

	virtual ~CCapture();

	// Generated message map functions
protected:
	//{{AFX_MSG(CCapture)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CAPTURE_H__E5620556_A135_11D1_A1BF_444553540000__INCLUDED_)
